#!/usr/bin/python
##### Smerni diagram kvadratne napake faze krozve odprtine - S53MV 04.02.2018 #####

import math,cmath	#uporabljene funkcije
import scipy.special as ss	#potrebuje instalacijo "python-scipy"

k=0.001		#korak risanja v radianih
s=20.0/math.log(10.0)
h=8.0		#premer odprtine v valovnih dolzinah

x=[]		#polja za risanje grafa
y=[]
z1=[]
z2=[]
z4=[]

def vsota(h,t,d):	#integracija vsote sevanja s kvadratno napako faze
	n=200.0
	kr=h/2.0/n
	v=complex(0.0,0.0)
	r=kr/2.0
	while r<h/2.0:
		v=v+r*ss.jn(0,2.0*math.pi*r*math.sin(t))*cmath.exp(complex(0.0,d*(2.0*r/h)**2))
		r=r+kr
	return abs(v)*4.0/(h*n)

t=k/2.0		#kot theta v radianih
while t<math.pi/2.0:
	x=x+[t]			#dodaj tocko v risbo
	f=(1.0+math.cos(t))/2.0
	ff=f*2.0*ss.jn(1,math.pi*h*math.sin(t))/(math.pi*h*math.sin(t)) #brez napake faze
	y=y+[s*math.log(math.fabs(ff))]
	d=math.pi/4.0	#kvadratna napaka faze pi/4
	z1=z1+[s*math.log(math.fabs(f*vsota(h,t,d)))]
	d=math.pi/2.0	#kvadratna napaka faze pi/2
	z2=z2+[s*math.log(math.fabs(f*vsota(h,t,d)))]
	d=math.pi	#kvadratna napaka faze pi
	z4=z4+[s*math.log(math.fabs(f*vsota(h,t,d)))]
	t=t+k			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
plt.plot(x,y,'r-',lw=2)
plt.plot(x,z1,'c-',lw=2)
plt.plot(x,z2,'b-',lw=2)
plt.plot(x,z4,'y-',lw=2)
plt.grid(True)
plt.axis([0.0,math.pi/2,-40,2])
plt.xticks([0.0,math.pi/8,math.pi/4,3*math.pi/8,math.pi/2])
plt.yticks([-40,-35,-30,-25,-20,-15,-10,-5,0])
plt.ylabel('Logaritemsko merilo [dB]')
plt.title('Kvadratna napaka faze okrogle odprtine')
plt.show()

#konec programa

